<%@ page
    import="com.websina.bean.*,com.websina.util.*"
%>
<html>
<head>
<title>Project field level access control</title>
<script type="text/javascript" src="script/item_mover.js"></script>
</head>
<body topmargin=0>
<%@ include file="_header.jspf" %>
<%      
  String msg = com.websina.servlet.SessionUtil.getMessage(session, request);
  String mainTitle = label.get("admin_permission");
  String subTitle = ""; 
  Project conf = null;
  if (projectId != null && projectId.trim().length()>0) {
    conf = Project.getInstance(projectId);
    mainTitle += ": ";
    subTitle = admin.getProjectDisplay(projectId);
    if (!conf.isPersisted()) {
      msg = MessageCode.get("servlet.project.not_persisted", lang);
      conf = null;
      projectId = null;
    }
  } else {
    projectId = null;
  }
%>
<%-- the title part --%>
<form style="margin-top:10px;">
<table cellpadding=0 cellspacing=0 width="100%" border=0>
  <tr><td align=right><font color="#000000"><b><%=label.get("project_label")%></b></font>&nbsp;
     <select name="project" 
        style="font-size:14px;"
        onChange="location.href='permission.jsp?projectId='+form.project.options[form.project.selectedIndex].value;">
        <%=ListMaker.makeOptionList(admin.getProjects(), currentProject) %>
        </select>
      <input type="button" class="button" value=" <%=label.get("edit_button")%> " 
      onClick="location.href='permission.jsp?projectId='+form.project.options[form.project.selectedIndex].value;" <%=(admin.getProjects().isEmpty())?"disabled":""%>>

  </td></tr>
  <tr class="f1"><td align=center height=30><font size=+1><b><%=mainTitle%></b></font>
  &nbsp;<font color="#cccc00"><b><%=subTitle%></b></font>
  </td></tr>
</table>
</form>
<center>
<p>
<%=com.websina.servlet.ServletUtil.formatMessage(msg)%>

<% if (conf == null) {
   if (msg == null) { // for instruction only %>
<table>
<tr><td height=380 valign=top>
<%=label.get("admin_common_intro")%>
</td></tr>
</table>
<% }} else { //if a project/permission is loaded for editing 
  String[] controlledFields = conf.controlledFields();
%>

<table cellpadding=0 cellspacing=0 border=0 width=95%>
<tr><td>
<%=label.get("admin_permission_text")%>
&nbsp;&nbsp;<a href="report.jsp?projectId=<%=projectId%>"><%=label.get("admin_report_link")%></a>
</td></tr>
</table> 

<form name="permissionForm" method="post" action="<%=contextPath%>/servlet/permission" onsubmit="return false;">
<input type="hidden" name="token" value='<%=com.websina.servlet.SessionUtil.getToken(session)%>'>
<input type="hidden" name="projectId" value="<%=projectId%>">
<table cellpadding=2 cellspacing=0 border=0 class="box">
<%-- the name part --%>
<tr class="header"><td colspan=3 align=center>
<font color="#ffffff"><b><%=label.get("admin_denied")%> <%=label.get("admin_groups")%></b></font>
</td></tr>
<%
  for (int index=0; index<controlledFields.length; index++) {
    String name = controlledFields[index];
    String title = label.get("admin_fieldLabel");
    boolean isButton = false;
    if (name.indexOf("_button") != -1) {
      title = label.get("admin_buttonLabel");
      isButton = true;
    }
    String[] srcList = Group.getInstance().codes(conf);
    String[] optionList;
    String[] optionList2;
    java.util.Set denied  = conf.getDeniedGroupsByField(name);
    java.util.Set denied2 = conf.getReadOnlyGroupsByField(name);
    if (denied == null) {
      optionList = null;
    } else {
      optionList = (String[])denied.toArray(new String[0]);
      srcList = ArrayUtil.remove(srcList, optionList);
    }
    if (denied2 == null) {
      optionList2 = null;
    } else {
      optionList2 = (String[])denied2.toArray(new String[0]);
      srcList = ArrayUtil.remove(srcList, optionList2);
    }
%>
<tr><td class="f1" colspan=3 align=center height=30 valign=bottom>
<font color="#000000"><b><%=title%>:</b></font>&nbsp; <%=label.get(name, projectId)%> (<%=name%>)
</td></tr>
<tr><td rowspan=2 class="e8" align=center>
&nbsp;<%=label.get("admin_available")%> <%=label.get("admin_groups")%>&nbsp;<br>
<select multiple size="8" name="<%=name%>_src">
   <%=ListMaker.makeOptionList(srcList) %>
</select></td>
<td class="e8" align=center width=100>
<input type="button" class="button" value="  >>  " onclick="move(form.<%=name%>_src,form.<%=name%>)"><br>
<input type="button" class="button" value="  <<  " onclick="move(form.<%=name%>,form.<%=name%>_src)">
</td>
<td class="e8" align=center>
&nbsp;<%=label.get("admin_denied")%> <%=label.get("admin_groups")%>&nbsp;<br>
<select multiple size="4" name="<%=name%>">
   <%=ListMaker.makeOptionList(optionList) %>
</select></td></tr>
<% if (isButton || name.equals("attachment") || name.equals("no_email") || name.equals("email_group_restrict") || name.equals("original_author_group") || name.equals("cc_mail") || name.equals("to_mail") || name.equals("bcc_mail") || name.equals("select_cc") || name.equals("audit_trail") || name.equals("ignore_closed")) { %>
<tr><td colspan=2 class="e8" align=center width=100>
&nbsp;</td></tr>
<% } else { %>
<tr><td class="e8" align=center width=100>
<input type="button" class="button" value="  >>  " onclick="move(form.<%=name%>_src,form.<%=name%>_ro)"><br>
<input type="button" class="button" value="  <<  " onclick="move(form.<%=name%>_ro,form.<%=name%>_src)">
</td>
<td class="e8" align=center>
&nbsp;<%=label.get("admin_readonly")%> <%=label.get("admin_groups")%>&nbsp;<br>
<select multiple size="4" name="<%=name%>_ro">
   <%=ListMaker.makeOptionList(optionList2) %>
</select></td>
</tr>
<% }} %>

<%-- finally the save/reset buttons --%>
<tr><td class="f1" colspan=3 align=center height=36 valign=bottom>
<input type="button" class="button" value="<%=label.get("save_button")%>" onClick=" 
<%
  for (int index=0; index<controlledFields.length; index++) {
    String name = controlledFields[index];
%>
  selectAll(form.<%=name%>);
<% if (!(name.indexOf("_button") != -1 
      || name.equals("attachment") 
      || name.equals("no_email") 
      || name.equals("email_group_restrict") 
      || name.equals("original_author_group") 
      || name.equals("cc_mail") 
      || name.equals("bcc_mail") 
      || name.equals("select_cc") 
      || name.equals("audit_trail") 
      || name.equals("ignore_closed"))) { %>
  selectAll(form.<%=name%>_ro);
<% }}%>
this.disabled=true; submit();">
<input type="button" class="button" value="<%=label.get("reset_button")%>"
onClick="location.href='permission.jsp?projectId=<%=projectId%>'">

</td></tr>
</table>
</form>
<% } %>
<%-- end of editing project/permission --%>
</center>
<%com.websina.servlet.JspUtil.include(application, request, response, out, "/jsp/customizable/footer.html");%>
</body>
</html>